<?php
	class CI_SETTINGS_MISC extends CI_SETTINGS
	{
		function get_config_file()
		{
			return CI_PATH_CONFIG.'/misc.xml';
		}

		function get_rmap($info)
		{
			return array(
				'rdate' 	=> array(
					'enabled'		=> $info['rdate_enabled'],
					'server'		=> $info['rdate_server']
				),
				'auto-addressbook'	=> array(
					'enabled'		=> $info['autoaddressbook_enabled'],
					'start'			=> $info['autoaddressbook_start']
				),
				'caller-id'			=> array(
					'caller-id'		=> $info['caller_dfl_caller_id'],
					'caller-name'	=> $info['caller_dfl_caller_name'],
					'caller-prefix'	=> $info['caller_dfl_prefix'],
				),
				'auth-policy'		=> $info['authpolicy_mode'],
				'chat-autoanswer'	=> array(
					'enabled'		=> $info['chatautoanswer_enabled'],
					'text'			=> $info['chatautoanswer_text']
				)
			);
		}

		function get_map($info)
		{
			return array(
				'rdate_enabled'					=> $info['rdate']['enabled'],
				'rdate_server'					=> $info['rdate']['server'],
				'autoaddressbook_enabled'		=> $info['auto-addressbook']['enabled'],
				'autoaddressbook_start'			=> $info['auto-addressbook']['start'],
				'caller_dfl_caller_id'			=> $info['caller-id']['caller-id'],
				'caller_dfl_caller_name'		=> $info['caller-id']['caller-name'],
				'caller_dfl_prefix'				=> $info['caller-id']['caller-prefix'],
				'authpolicy_mode'				=> $info['auth-policy'],
				'chatautoanswer_enabled'		=> $info['chat-autoanswer']['enabled'],
				'chatautoanswer_text'			=> $info['chat-autoanswer']['text']
			);
		}
		
		function get_info()
		{
			$config=ci_get_unserialized_xml($this->get_config_file());
			return $this->get_map($config);
		}

		function task_save($info)
		{
			if ($info['rdate_enabled'] == 'true' && !$info['rdate_server'])
				return ci_response_error(
					'field',
					array(
						'fieldname' => 'rdate_server',
						'desc'		=> ci_lbl('libsettings_misc.error.missing-rdate_server')
					)
				);

			if ($info['autoaddressbook_enabled'] == 'true' && !$info['autoaddressbook_start'])
				return ci_response_error(
					'field',
					array(
						'fieldname' => 'autoaddressbook_start',
						'desc'		=> ci_lbl('libsettings_misc.error.missing-autoaddressbook_start')
					)
				);

			if ($info['chatautoanswer_enabled'] == 'true' && !$info['chatautoanswer_text'])
				return ci_response_error(
					'field',
					array(
						'fieldname' => 'chatautoanswer_text',
						'desc'		=> ci_lbl('libsettings_misc.error.missing-chatautoanswer_text')
					)
				);
			
			ci_save_xml($this->get_config_file(), $this->get_rmap($info));
			return ci_response_ok();
		}
	}
?>