<?php
	require_once(CI_PATH_LIBS.'/config.inc.php');

	class CI_TRUNKS_SIP extends CI_CONFIG
	{
		function CI_TRUNKS_SIP()
		{

		}
		
		function get_config_file()
		{
			return CORE_PATH_BASE.'/config/drivers/sip.xml';
		}

		function parse_destination($dst)
		{
			list($driver, $destination, $port)=split(':', $dst);
			list($destination, $post)=split('#', $destination);

			$user='';
			if (strpos($destination, '@') !== false)
				list($user, $host)=split('@', $destination);
			else
				$host=$destination;

			$trunks=$this->get_trunks();
			foreach ($trunks as $info)
			{
				if ($info['name'] == $driver.':'.$destination)
				{
					$trunk=$info;
					break;
				}
				elseif ($info['info']['link-mode'] == 'friend')
				{
					$host2=$info['info']['ip'] ? $info['info']['ip'] : '$'.$info['info']['username'];
					
					if ($host == $host2)
					{
						$trunk=$info;
						$did=$user;
						break;
					}
				}
			}

			return array(
				'trunk'	=> $trunk,
				'did'	=> $did,
				'post'	=> $post
			);
		}

		function get_trunks()
		{
			$out=array();
			$items=ci_get_unserialized_xml($this->get_config_file());

			$items=$items['agents'];
			if (!$items) return array();

			if (!$items['item'][0]) $items['item']=array($items['item']);

			foreach ($items['item'] as $item)
			{
				if ($item['link-mode'] == 'user')
				{
					$name=$item['username'].'@127.0.0.1';
				}
				else if ($item['link-mode'] == 'friend')
				{
					$name=$item['ip'] ? $item['ip'] : '$'.$item['username'];

					/*if ($item['ip'] && $item['port']) $name.=':'.$item['port'];
					elseif ($item['ip']) $name.=':5060';*/
				}

				$desc2=ci_lbl('libtrunks.sip.'.$item['link-mode']).' '.($item['username'] ? $item['username'] : $item['ip']);
				
				array_push($out, array(
					'info'	=> $item,
					'desc'	=> $item['desc'],
					'desc2'	=> $desc2,
					'name'	=> 'sip:'.$name
				));
			}
			
			return $out;
		}
	}
?>