#!/usr/bin/env python

# Copyright and license: Please refer to LICENSE.TXT

import sys
import os
import os.path
import httplib
from urlparse import urlparse
import string
import urllib
import re
import time
from xml.sax import saxutils

_selfpath=(os.path.dirname(os.path.realpath(__file__)).split('/'))[:-1]
_selfpath.append('pylibs')
_libspath='/'.join(_selfpath)
sys.path.append(_libspath)

from castiron import *

# Variables replace
def set_vars(txt, replace):
	if not txt: txt=""

	for k in replace.keys():

		if not replace[k]: replace[k]=""
		txt=re.sub(r'\$\{'+k+'\}', replace[k], txt)

	return txt

# Check config parameters
CORE_CONF_SYSTEM		= xml_to_array(CORE_PATH_BASE+'/config/system.xml')
CASTIRON_CONF_MISC		= xml_to_array(CASTIRON_PATH_BASE+'/config/misc.xml')

if not os.path.isfile(CASTIRON_PATH_BASE+'/data/user_status_updated.evt'): sys.exit(0)

fp=open(CASTIRON_PATH_BASE+'/data/user_status_updated.event', 'r')
url=re.sub(r'[\n\r]', '', fp.read())
fp.close()

try:
	o = urlparse(url)

	if o.port:
		conn = httplib.HTTPConnection(o.hostname+':'+str(o.port))
	else:
		conn = httplib.HTTPConnection(o.hostname)

	qsa={}
	for k in os.environ.keys():
		qsa[k]=urllib.quote(os.environ[k])

	qs=set_vars(o.query, qsa)

	conn.request("GET", o.path+'?'+qs)
	res=conn.getresponse()

	data = res.read()
	res.close()

except:
	sys.exit(-1)

